package Graph;
import java.util.Arrays;
public class VertexKey {

    private final float[] coords;

    public VertexKey(float[] coordinates) {
        this.coords = coordinates;
    }

    @Override
    public boolean equals(Object anotherVertex) {
        if (anotherVertex == this) {
            return true;
        }
        if (anotherVertex == null) {
            return false;
        }
        if (anotherVertex.getClass() != this.getClass()) {
            return false;
        }
        VertexKey vertexKey = (VertexKey) anotherVertex;
        return Arrays.equals(this.coords, vertexKey.coords);
    }

    @Override
    public int hashCode() {
        return Arrays.hashCode(this.coords);
    }
}